/*
    Origin: ftp://ftp.jgaa.com/pub/unsupported/groupstats*.tgz
    Written by: Jarle Aase <jgaa@jgaa.com> (http://www.jgaa.com)


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */

class Stats
{
public:

  Stats()
    : mNumBytes(0), mNumPosts(0)
  {
  }

  Stats(const Stats& v)
    : mNumBytes(v.mNumBytes), mNumPosts(v.mNumPosts)
  {
  }

  void operator = (const Stats& v) 
  {
    mNumBytes = v.mNumBytes;
    mNumPosts = v.mNumPosts;
  }

  long long mNumBytes;
  long long mNumPosts;
};

class SortedStats
{
 public:
  
  SortedStats(const SortedStats& v)
    : mpName(v.mpName), mpStats(v.mpStats), mSortByPosts(v.mSortByPosts)
  {}

  SortedStats(const char *name, const Stats *pstats, const bool SortByPosts = false)
    : mpName(name), mpStats(pstats), mSortByPosts(SortByPosts)
  {}

  inline bool operator < (const SortedStats& v) const
  {
    if (mSortByPosts)
      return mpStats->mNumPosts > v.mpStats->mNumPosts;

    return mpStats->mNumBytes > v.mpStats->mNumBytes;
  }

  const char *mpName;
  const Stats *mpStats;
  bool mSortByPosts;
};


typedef std::pair<std::string, Stats> stats_t;
typedef std::map<std::string, Stats> stats_map_t;
typedef std::multiset<SortedStats> sort_set_t;

